{Plot Utility for Horniman Wayne Ledger Data
Copyright (C) 2006 wes williams

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
}


{NOTE: This code uses the RXSpinEdit component from the opensource RXLib
 component set}

{#backup h.bdb}

unit splot1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, RXSpin, Mask, ToolEdit;

type
  TForm1 = class(TForm)
    Panel2: TPanel;
    Image1: TImage;
    Panel3: TPanel;
    RxSpinEdit2: TRxSpinEdit;
    Label1: TLabel;
    RadioGroup2: TRadioGroup;
    RxSpinEdit1: TRxSpinEdit;
    Label2: TLabel;
    RadioGroup1: TRadioGroup;
    CheckBox1: TCheckBox;
    Button1: TButton;
    SaveDialog1: TSaveDialog;
    Label3: TLabel;
    Label4: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Panel2Resize(Sender: TObject);
    procedure UpdatePlot(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure RxSpinEditMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure RxSpinEditMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
    Data:TStringList;
    b:TBitmap;
    Spinning:Boolean;
    procedure ParseData;
    procedure Plot;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
uses RxGIF;
{$R *.DFM}
const yspare:integer=20;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Data:=TStringList.Create;
  SaveDialog1.InitialDir:=ExtractFilePath(ParamStr(0));
  if fileExists(ExtractFilePath(ParamStr(0))+'h.bdb') then begin
   Data.LoadFromFile(ExtractFilePath(ParamStr(0))+'h.bdb');
   ParseData;
   b:=TBitmap.Create;
   b.width:=panel2.width;
   b.height:=panel2.Height;
   Plot;
  end
  else begin
    MessageDlg('The Ledger data is missing.', mtError, [mbOK], 0);
    Button1.Enabled:=false;
  end;
  Spinning:=false;
  label3.caption:='Date:';
  label4.caption:='Serial:';
end;


procedure TForm1.ParseData;
var ts,ss:string; i,date,yr,mn,dy,ser:integer;
    r:integer;
begin
  if Data[0]='Version X01' then begin
   r:=5;
   Data.Delete(0);
  end
  else r:=4;

  //Remove Ledger/Page
  for i:=0 to Data.Count-1 do Data[i]:=Copy(Data[i],r,255);

  //Remove Undated
  i:=0;
  repeat
   if Copy(data[i],1,6)='000000' then data.Delete(i) else inc(i);
  until i>=data.Count;
  //First field is now date, so sort by date
  Data.Sorted:=true;

  //Turn off sort and modify data
  Data.Sorted:=false;
  for i:=0 to Data.Count -1 do begin
    ts:=Data[i];

    yr:=StrToInt(Copy(ts,1,2));
    if yr<20 then yr:=(yr + 66)*360
    else yr:=(yr-34) * 360;

    mn:=(StrToInt(Copy(ts,3,2))-1)*30;

    dy:=StrToInt(Copy(ts,5,2))-1;
    if dy>29 then dy:=29;

    if yr=-1 then date:=-1 else date:=yr + mn + dy;

    ss:=Copy(ts,7,255);
    case ss[Length(ss)] of
     '0'..'9': ser:=StrToInt(ss);
    else ser:=StrToInt(Copy(ss,1,Length(ss)-1));
    end;

    ss:=IntToStr(ser);
    while length(ss)<5 do ss:='0'+ ss;


    Data.Objects[i]:=TObject(date);
    Data[i]:=ss;

  end;

end;

procedure TForm1.Plot;
var x,y,xs,ys,i,xspare,gs,ss,ymin:integer;
    o:array[1..32768] of boolean;
begin
 screen.Cursor:= crHourglass;
 b.Canvas.Rectangle(-1,-1,b.width+1,b.height+1);
 xspare:=b.Canvas.TextWidth('18888')+ 5 ;
 b.Canvas.Pen.Color:=$00000000;

 b.Canvas.MoveTo(xspare,10);
 b.Canvas.LineTo(xspare,b.height-yspare);
 b.Canvas.LineTo(b.width-10,b.height-yspare);
 case RadioGroup2.ItemIndex of
  5:xs:=30; //12
  4:xs:=15;//24 per year
  3:xs:=8;//45 per yr
  2:xs:=4;//90 per yr
  1:xs:=2;//180 per yr
 else xs:=1;//360 per yr
 end;

 case RadioGroup1.ItemIndex of
  5:begin ys:=40; gs:=4000 end;
  4:begin ys:=20; gs:=2000 end;
  3:begin ys:=10; gs:=1000 end;
  2:begin ys:=5; gs:=500 end;
  1:begin ys:=2; gs:=200 end;
 else begin ys:=1; gs:=100 end;
 end;

 b.Canvas.Pen.Color:=$00C0C0C0;

 //x axis
 b.Canvas.TextOut(xspare,b.Height - yspare+1,IntToStr(Trunc(RxSpinEdit2.Value)));
 if RadioGroup2.ItemIndex>3 then i:=4 else i:=1;
 repeat
   x:=  (i * (360 DIV xs)) +xspare;
   y:=b.height - yspare +1;
   b.Canvas.MoveTo(x,y);
   b.Canvas.LineTo(x,10);
   b.Canvas.TextOut(x,y,IntToStr(Trunc(RxSpinEdit2.Value)+i));
   if RadioGroup2.ItemIndex>3 then inc(i,4) else inc(i);
 until x >= b.width + (360 DIV xs) +xspare;

 //y axis
 b.Canvas.TextOut(1,b.Height - yspare-5,IntToStr(Trunc(RxSpinEdit1.Value)));
 i:=1;
 repeat
   y:= b.height - yspare - (i * 100);
   b.Canvas.MoveTo(1,y);
   b.Canvas.LineTo(b.width-10,y);
   b.Canvas.TextOut(1,y,IntToStr(Trunc(RxSpinEdit1.Value)+ (i * gs)));
   inc(i);
 until y <= 100;

 ymin:=(Trunc(RxSpinEdit2.value) - 1834) * 360;

 for i:=1 to 32768 do o[i]:=true;
 i:=0;
 repeat
  ss:=StrToInt(data[i]);
  if (ss<32769) and o[ss] then
   if ss>=Trunc(RxSpinEdit1.value) then begin
    y:=b.height-yspare - ((ss - Trunc(RxSpinEdit1.value)) DIV ys + 1);

    x:=Integer(data.Objects[i]);

    if x<>-1 then begin
     x:= x - ymin;
     x:= (x  div xs) + xspare +1;
     if x>xspare then b.Canvas.Pixels[x,y]:=0;
    end;
   end;
  inc(i);
  if Checkbox1.Checked and  (ss<32769) then o[ss]:=false;
 until i=Data.Count;


 Image1.Canvas.Draw(0,0,b);
 screen.Cursor:= crDefault;

end;

procedure TForm1.Button1Click(Sender: TObject);
var Gif:TGIFImage;
begin
 if SaveDialog1.Execute then begin
  gif:=TGIFImage.create;
  try
   gif.assign(b);
   gif.SaveToFile(SaveDialog1.FileName);
  finally
   gif.Free;
  end;
 end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 b.free;
 data.free;
end;

procedure TForm1.Panel2Resize(Sender: TObject);
begin
 b.width:=Image1.Width;
 b.Height:=Image1.Height;
 Image1.Picture.Bitmap.Assign(b);
 Plot;
end;

procedure TForm1.UpdatePlot(Sender: TObject);
begin
 if Spinning then exit;
 Plot;
end;

procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var dy,dm,s,xspare,dd:integer; ts:string;
begin
  //output mouse
  case RadioGroup1.ItemIndex of
   5: s:=(b.height - yspare + 1 - y)*40 + Trunc(RxSpinEdit1.value);
   4: s:=(b.height - yspare + 1 - y)*20+  Trunc(RxSpinEdit1.value);
   3: s:=(b.height - yspare + 1 - y)*10+  Trunc(RxSpinEdit1.value);
   2: s:=(b.height - yspare + 1 - y)*5+  Trunc(RxSpinEdit1.value);
   1: s:=(b.height - yspare + 1 - y)*2+  Trunc(RxSpinEdit1.value);
  else s:=b.height - yspare + 1 - y+  Trunc(RxSpinEdit1.value);
  end;
  xspare:=b.Canvas.TextWidth('18888')+ 5 ;
  case RadioGroup2.ItemIndex of
   5:dd:=12;
   4:dd:=24;
   3:dd:=45;
   2:dd:=90;
   1:dd:=180;
   else dd:=360;
   end;

   dy:= ((x - xspare) DIV dd)+Trunc(RxSpinEdit2.value);
   dm:=  (((x - xspare) mod dd)*12) DIV dd;

  case dm of
    0:ts:= 'Date: Jan ';
    1:ts:= 'Date: Feb ';
    2:ts:= 'Date: Mar ';
    3:ts:= 'Date: Apr ';
    4:ts:= 'Date: May ';
    5:ts:= 'Date: Jun ';
    6:ts:= 'Date: Jul ';
    7:ts:= 'Date: Aug ';
    8:ts:= 'Date: Sep ';
    9:ts:= 'Date: Oct ';
    10:ts:= 'Date: Nov ';
    11:ts:= 'Date: Dec ';
   else ts:= 'Date: ';
   end;

  label3.Caption:=ts + IntToStr(dy);

  label4.Caption:='Serial:'+IntToStr(s);
end;


procedure TForm1.RxSpinEditMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
    Spinning:=true;
end;

procedure TForm1.RxSpinEditMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    Spinning:=false;
end;

end.
