{Search Utility for Horniman Wayne Ledger Data
Copyright (C) 2006 wes williams

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
}
unit sunit;
{#BACKUP h.bdb}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TEntry = class
    public
      entry:string;
    end;

  TForm1 = class(TForm)
    Panel1: TPanel;
    Edit1: TEdit;
    Button1: TButton;
    Memo1: TMemo;
    Label1: TLabel;
    Button3: TButton;
    RadioGroup1: TRadioGroup;
    RadioGroup2: TRadioGroup;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Button3Click(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
  private
    { Private declarations }
    procedure CleanDatabase;
  public
    { Public declarations }
    Version:integer;
    hbdb:TStringList;
    Data:TStringList;
    function WriteFull(r:string):string;
    procedure ParseData;
  end;

var
  Form1: TForm1;

implementation

uses sunit2;

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  Data:=TStringList.Create;
  hbdb:=TStringList.Create;
  if fileExists(ExtractFilePath(ParamStr(0))+'h.bdb') then begin
   hbdb.LoadFromFile(ExtractFilePath(ParamStr(0))+'h.bdb');

   Version:=0;
   if hbdb[0]='Version X01' then begin
    Version:=1;
    hbdb.Delete(0);
   end
   else MessageDlg('The Ledger data is possibly corrupted.', mtError, [mbOK], 0);
   ParseData;
  end
  else begin
    MessageDlg('The Ledger data is missing.', mtError, [mbOK], 0);
    Button1.Enabled:=false;
  end;
end;



procedure TForm1.ParseData;
var i:integer; s:TEntry; ts,ts2:string; tc:char;

 procedure AddEntry;
 var sn:string;
 begin
   s:=TEntry.Create;
   ts:=Writefull(hbdb[i]);
   s.Entry:=ts;

   if Version=0 then ts:=Copy(hbdb[i],10,255)
   else ts:=Copy(hbdb[i],11,255);

   if ts[1]='0' then ts:=Copy(ts,2,255);
   case ts[length(ts)] of
    '0'..'9': sn:=ts
   else sn:=Copy(ts,1,Length(ts)-1);
   end;
   Data.AddObject(sn,s);
 end;


begin
 CleanDatabase;
 for i:=0 to hbdb.Count -1 do
 begin
  ts2:=hbdb[i];
  tc:=Upcase(ts2[length(ts2)]);
  case RadioGroup1.ItemIndex of
   0:AddEntry;
   1: if not(tc in ['0'..'9']) then AddEntry;
  end;
 end;
 Memo1.Lines.Add('      ');
  case RadioGroup1.ItemIndex of
   0:ts:='Full ';
   1:ts:='Noted only ';
  end;

 Memo1.Lines.Add(ts+'Database contains '+ IntToStr(Data.Count)
                 + ' entries.');

end;

function TForm1.WriteFull(r:string):string;
var ts,ss,ts1:string;
begin
  case r[1] of
   '0': ts:='C1050 ';
   '1': ts:='C1051 ';
   '2': ts:='C1052 ';
   '3': ts:='C1053 ';
   '4': ts:='C1054 ';
   'a': ts:='C104a ';
   '6': ts:='C1046 ';
   '7': ts:='C1047 ';
   '8': ts:='C1048 ';
   '9': ts:='C1049 ';
   ',': ts:='SD01 ';
  else ts:='Error!';
  end;
  //page
  ts1:=Copy(r,2,3);
  if ts1[1]='C' then ts1:=ts1[1]+'0'+ts1[2]+'.'+ts1[3];
  ts:=ts + 'page '+ ts1;

  //date
  ts1:=Copy(r,5,6);


  if ts1= '000000' then
   ts := ts + ': undated'
  else begin
   if Copy(r,9,2)='00' then ts:=ts + ': '
   else ts:=ts + ': '+  Copy(r,9,2)+' ';

  case StrToInt(Copy(r,7,2)) of
   1:ts:=ts +'Jan';
   2:ts:=ts +'Feb';
   3:ts:=ts +'Mar';
   4:ts:=ts +'Apr';
   5:ts:=ts +'May';
   6:ts:=ts +'Jun';
   7:ts:=ts +'Jul';
   8:ts:=ts +'Aug';
   9:ts:=ts +'Sep';
   10:ts:=ts +'Oct';
   11:ts:=ts +'Nov';
   12:ts:=ts +'Dec';
  end;

  if StrToInt(Copy(r,5,2))<34 then
   ts:= ts +  ' 19'+ Copy(r,5,2)
  else ts:= ts +  ' 18'+ Copy(r,5,2) ;
  end;

  //serial
   ss:='Serial ' + Copy(r,11,255);
   if not(ss[length(ss)] in ['0'..'9']) then
   case ss[length(ss)] of
   'A' : ss:=Copy(ss,1,Length(ss)-1) + ' (Sedgewick);';
   'B' :  ss:=Copy(ss,1,Length(ss)-1) + ' (Bass);';
   'C' : ss:=Copy(ss,1,Length(ss)-1) + ' (Chidley);';
   'D' : ss:=Copy(ss,1,Length(ss)-1) + ' (Double);';
   'E' : ss:=Copy(ss,1,Length(ss)-1) + ' (Harmonium);';
   'F' : ss:=Copy(ss,1,Length(ss)-1) + ' (?Frames);';
   'G' : ss:=Copy(ss,1,Length(ss)-1) + ' (Case);';
   'H' : ss:=Copy(ss,1,Length(ss)-1) + ' (Anglo-German);';
   'J' : ss:=Copy(ss,1,Length(ss)-1) + ' (Simpson);';
   'L' : ss:=Copy(ss,1,Length(ss)-1) + ' (Lachenal);';
   'M' : ss:=Copy(ss,1,Length(ss)-1) + ' (Cramer);';
   'N' : ss:=Copy(ss,1,Length(ss)-1) + ' (Nickolds);';
   'P' : ss:=Copy(ss,1,Length(ss)-1) + ' (Prowse);';
   'R' : ss:=Copy(ss,1,Length(ss)-1) + ' (Rudall);';
   'S' : ss:=Copy(ss,1,Length(ss)-1) + ' (Scates);';
   'T' : ss:=Copy(ss,1,Length(ss)-1) + ' (Turner);';
   'X' : ss:=Copy(ss,1,Length(ss)-1) + ' (Rock Chidley);';
   '?','*' : ss:=Copy(ss,1,Length(ss)-1) + ' (?Case/Boosey);';
   '+' : ss:=Copy(ss,1,Length(ss)-1) + ' (! 248 or higher?);';
  else ss:=Copy(ss,1,Length(ss)-1) + ' (!Uncertain);';
  end
  else ss:=ss+';';

  result:=ss + ts;
end;


procedure TForm1.Button1Click(Sender: TObject);
var i,sn,finds,loops,loops1:integer; ts,ss:string;
//    tl:tstringlist;
begin
 try
   ts:=trim(edit1.text);
   while POS(' ',ts)<>0 do
     ts:=Copy(ts,1,POS(' ',ts)-1)+ Copy(ts,POS(' ',ts)+1,255);


   loops:=1;
   if POS('+',ts)<>0 then begin
     ss:=Copy(ts,1,POS('+',ts)-1);
     try
      loops:=StrToInt(Copy(ts,POS('+',ts)+1,255));
     except
       MessageDlg('"'+Copy(ts,POS('+',ts)+1,255)+ '" is not a valid number.', mtError, [mbOK], 0);
       exit;
     end;
   end
   else ss:=edit1.text;
   sn:=StrToInt(ss); //Only to throw an exception
 except
   MessageDlg('"'+Edit1.text+ '" is not a valid serial number.', mtError, [mbOK], 0);
   exit;
 end;
// tl:=tstringlist.create;
// try
  memo1.clear;
  screen.Cursor:=crhourglass;
  loops1:=loops;
  repeat
   finds:=0;
   for i:=0 to Data.Count-1 do
   if Data[i]=ss then begin
     ts:=TEntry(data.Objects[i]).Entry;
     memo1.lines.Add(ts);
     inc(finds);
   end;
   if (finds=0) and ( (RadioGroup2.ItemIndex=0) or (loops1=1) )
   then memo1.lines.Add('Serial '+ ss + ' not found');
   dec(loops);
   ss:=IntToStr(StrToInt(ss) + 1);
  until loops<=0;
//  memo1.Lines.Assign(tl);
// finally
  screen.Cursor:=crDefault;
//  tl.free;
// end;
end;

procedure TForm1.CleanDatabase;
var i:integer;
begin
 if Data.Count=0 then exit;
 for i:=0 to Data.Count -1 do Data.Objects[i].Free;
 Data.Clear;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 CleanDatabase;
 Data.Free;
 hbdb.Free;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Button1.Enabled  and  (Key= vk_return) then Button1Click(Sender);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
 Form2.Show;
end;

procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
 ParseData;
end;

end.
